using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace PicToAscii2
{
    public partial class Form1 : Form
    {

        string appstartfolder = "";
        List<int> keys = new List<int>();
        List<int> values = new List<int>();

        public Form1() {
            InitializeComponent();
            appstartfolder = Application.StartupPath;
        }

        private void button1_Click(object sender, EventArgs e) {
            if (openFileDialog1.ShowDialog(this) == DialogResult.OK) {
                textBox1.Text = openFileDialog1.FileName;
            }


        }

        private void btnExit_Click(object sender, EventArgs e) {
            Application.Exit();
        }

        private void panel1_Paint(object sender, PaintEventArgs e) {
            System.Drawing.Drawing2D.LinearGradientBrush lb =
                new System.Drawing.Drawing2D.LinearGradientBrush(
                    new Point(),
                    new Point(0, panel1.Height - 1),
                    Color.FromArgb(192, 192, 192),
                    Color.FromArgb(215, 215, 215));
            e.Graphics.FillRectangle(lb, 0, 0, panel1.Width, panel1.Height);
            e.Graphics.DrawLine(Pens.White, 0, 1, panel1.Width, 1);

        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e) {
            //First load the dictionary.
            string dicFile = Path.Combine(appstartfolder, "dic.txt");
            string s,t;
            string[] spl;
            //Dictionary<int, int> intenseChar = new Dictionary<int, int>();

            StreamReader sr = new StreamReader(dicFile);

            //Load all the lines
            while ((s = sr.ReadLine())!=null) {
                spl = s.Split(new char[] { ' ' });
                keys.Add(int.Parse(spl[0]));
                values.Add(int.Parse(spl[1]));
                //intenseChar.Add(int.Parse(spl[0]), int.Parse(spl[1]));
            }

            //That's 2% done
            backgroundWorker1.ReportProgress(2);



            //Now, take in the picture..
            Bitmap bmp = null;
            try {
                bmp = (Bitmap)Bitmap.FromFile(textBox1.Text);
            }
            catch {
                MessageBox.Show("No File or File format not supported");
            }


            //Now get the intensity values part by part.
            int deltax = 8;
            int deltay = 15;


            //Intensity:  0 is total blackout, 918 is Snow White
            //Character:  7682 is balckout   , 719 is White!

            StreamWriter sw = new StreamWriter(
                Path.Combine(appstartfolder, "out.txt"));

            //Iterate over the bitmap
            for (int i = 0; i < bmp.Height/deltay; i++) {
                for (int j = 0; j < bmp.Width/deltax; j++) {
                    double d = getIntensityOfPicture(j * deltax, i * deltay,
                        (j+1) * deltax, (i + 1) * deltay, bmp);

                    char ch = getTheCharacter(d);
                    sw.Write(ch);

                }
                sw.WriteLine();
                if(i%100==0)backgroundWorker1.ReportProgress(2 + (i * 98 / bmp.Height / deltay));
            }
            sw.Flush();
            sw.Close();
            //MessageBox.Show("Max: " + maxintensity + ", Min: " + minIntensity);


        }

        private char getTheCharacter(double d) {
            //Intensity:  0 is total blackout, 918 is Snow White
            //Character:  7682 is balckout   , 719 is White!

            //d = (918 - d) * (7682 - 719) / 918 + 719;  //  <-- correct
            d = (918 - d) * (7682 - 719) / 650 + 719;

            //Now, get the character.
            int i = 0;
            for (i = 0; i < keys.Count; i++) {
                if (keys[i] > d) break;
            }
            i--;
            if (i < 0) i = 0;

            return ((char)values[i]);

        }


        private double getIntensityOfPicture(int x1, int y1, int x2, int y2, Bitmap bmp) {
            double d = 0;
            Color c;
            for (int i = y1; i < y2; i++) {
                for (int j = x1; j < x2; j++) {
                    c = bmp.GetPixel(j, i);
                    d += (c.R + c.G + c.B) / 100.0;
                }
            }

            return d;
        }

        private void backgroundWorker1_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressBar1.Value = e.ProgressPercentage;
            lblProgress.Text = e.ProgressPercentage + "%";
            lblProgress.Refresh();
        }

        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
            progressBar1.Value = 0;
            lblProgress.Text = "done";
        }

        private void button2_Click(object sender, EventArgs e) {
            backgroundWorker1.RunWorkerAsync();
        }
    }
}